public hd
public comando
public resposta, retorno
public lidos
public ret, sair

 hd = fopen("FISCNET0", 2)		&& Abre para escrita e leitura
 if ferror() > 0
	? "Erro na abertura do device driver FISCNET0!"
	? "Codigo do erro "+str( ferror(), 3 )
	quit
 endif

 * Solicita ao dispositivo a transmisso do comando 'VendaItem'

 && Monta: <InicioCmdDD><ComandoDD><CR><LF>
 &&        STX @ CR LF
 comando = Chr(2) + '@' + Chr(13) + Chr(10)

 && Monta o <ParametrosDD>
 && Primeiramente, monta o valor obrigatorio ; 
 comando = comando + ";"				

 && Monta as secoes 2 e 3 do Protocolo FiscNET
 comando = comando + "VendeItem"		&& Monta o comando FiscNET
 comando = comando + "; "			&& Monta o caracter obrigatrio ; 

 && Inicio da montagem dos parametros do comando FiscNET
 comando = comando + "CodAliquota=-2 " 	&& Situao Tributria
 comando = comando + "CodProduto=" + Chr(34) + "7891000123456" + Chr(34) 	&& Codigo do Produto
 comando = comando + "NomeProduto=" + Chr(34) + "BISC VITAMINADO" + Chr(34) && Nome Produto
 comando = comando + "PrecoUnitario=1,50 "						&& Valor Unitario
 comando = comando + "Quantidade=3 "							&& Quantidade
 comando = comando + "Unidade=" + Chr(34) + "Un" + Chr(34)		&& Unidade

 && Finaliza o comando com <CR><LF>
 comando = comando + Chr(13) + Chr(10)

 && Escreve comando no dispositivo FISCNET0, ...
 && ...indicando que deve ser enviado o comando FiscNET VendeItem 
 escritos = fwrite( hd, comando, Len(comando) )

 && Retorno da Transmissao do Comando '@': foi enviado ou nao?
 resposta = Space(50)
 lidos = fread(hd,@resposta,50)
 if lidos > 3
	retorno = Substr(resposta,3,2)

	if  retorno <> "00"		&& Caso nao seja "00"
		? "Erro "+retorno+" ao enviar comando 'VendaItem'!"
	else			&& seno, enviou comando!
		? "Comando enviado ao equipamento fiscal..."
	endif
 else
	? "Nao conseguiu ler do dispositivo FISCNET0."
 endif

 && Obtm resposta do equipamento fiscal
 LeRetorno ("A", 2)
 LeRetorno ("E", 3)
 
 fclose( hd )
quit


***************************************************
*** Funcao generica para leitura do retorno do ECF
***************************************************
Procedure LeRetorno(Cmd, Secao)
 && Monta comando Cmd para o dd, solicitando cod. de erro: secao [Secao] do FiscNET
 comando = Chr(2) + Cmd + Chr(13) + Chr(10)

 erro = .f.
 sair = .f.
 ret = 2			&& Assume retorno nao_pronto 
 do while ret == 2 .and. !sair

 && Escreve o comando no dispositivo
	escritos = fwrite( hd, comando, Len(comando) )

	&& Retorno esta disponivel?
	resposta = Space(100)
	lidos = fread(hd,@resposta,100)
	if lidos > 3
		retorno = Substr(resposta,3,2)
		ret = val(retorno)
		Do case
			case ret == 0   && Recebeu resposta do DD
				&& Recebeu resposta OK.
				sair = .t.

			case ret == 4   && Fora de Linha
				? "Impressora fora de linha!"
				sair = .t.
				erro = .t.

			case ret == 5   && Comando nao implementado
				? " Comando nao implementado!"
				sair = .t.
				erro = .t.

			case ret == 6   && Erro de sintaxe no comando
				? "Erro de sintaxe no comando enviado ao dd!"
				sair = .t.
				erro = .t.

			otherwise	       && Nao pronto
				&& Somente espera
		Endcase
	else
		? "Nao conseguiu ler do dispositivo FISCNET0."
		sair = .t.
		erro = .t.
	endif
 enddo

 && Pega resposta da impressora
 if !erro
	resposta = Space(100)
	fread(hd,@resposta,100)
	? "Retorno FiscNET secao " + ltrim(str(secao)) + " => "+ ;
		subs(strtran(resposta,chr(13)),2,len(resposta)-1)
 endif
return
